{% set distros = { 'ubuntu' : ['jammy', 'lunar'] } %}
{% set variants = ["curl", "scm", ""] %}

include:
{% for distro in distros %}
    {% for suite in distros[distro] %}
      {% for variant in variants %}
  - project: 'nirvati/ci'
    file: '/docker.yml'
    inputs:
      username: $HARBOR_USERNAME
      password: $HARBOR_PASSWORD
      registry: $HARBOR_HOST
      project: library
      container: $CI_PROJECT_NAME
      {% if variant == "" %}
      tag: {{suite}}
      suffix: {{suite}}
      stage-suffix: ""
      dir: ./{{distro}}/{{suite}}
      {% else %}
      tag: {{suite}}-{{variant}}
      suffix: {{suite}}-{{variant}}
      stage-suffix: -{{variant}}
      dir: ./{{distro}}/{{suite}}/{{variant}}
      {% endif %}
      {% endfor %}
    {% endfor %}
{% endfor %}

# No order is perfect here, but this is not too complicated and works just fine
# TODO: Improve default CI config to use needs: and then we can remove the stages
stages:
  {% for variant in variants %}
    {% if variant == "" %}
- docker-build
- docker-deploy
    {% else %}
- docker-build-{{variant}}
- docker-deploy-{{variant}}
    {% endif %}
  {% endfor %}

